<?php

/**
 * 画像操作クラス
 * @param $image 操作する画像のパス
 *
 *
**/
/*
CREATE TABLE tbl_imgmngr
(
  img_code serial NOT NULL,	--登録コード
  img_path text NOT NULL,	--格納フォルダ BASE_PATH以下から (例: /global-image/page)
  img_fname text NOT NULL,	--画像名称（実ファイル名）
  img_name text,					--画像名称（実ファイル名ではありません、管理画面表示用）
  primary key (img_code)
)
*/

class imgmngrDB extends Model{
	var $img_code;
	var $former_image;
	var $former_width;
	var $former_height;
	var $name;

	var $db=null;
	var $image_file = null;

	var $media_service_api = array(
		//'youtube'=>'http://gdata.youtube.com/feeds/api/videos/'
    'youtube'=>'https://www.googleapis.com/youtube/v3/videos/'
		,'vimeo'=>'https://vimeo.com/api/oembed.xml'
	);

	function imgmngrDB(){
		$this->__construct();
	}

	function __construct(){
		//$this->setFormerImage($image);
		Model::__construct();
		$this->db = new DataBase();
	}

	function setImage($image) {
		$this->image_file = $image;
		$this->setFormerImage($this->image_file);
	}

	function setName($name){
		$this->name=$name;
	}

	/*
	 * コードから画像情報取得
	 */
	// 2009.07.24 mod by sugi
	// 引数に公開用のベースとなるパス、pageu_codeとファイル名に付けるインデックスを追加
	//function getImageFromCode($img_code) {
	function getImageFromCode($img_code, $bpath, $pageu_code, $idx) {
		if(!is_numeric($img_code)) {
			return null;
		}
		$data = null;
		$sql = 'select * from tbl_imgmngr where img_code = ? ';
		$result = $this->db->prepare($sql, array($img_code));
		if($result) {
			$data = $result->fetchRow(DB_FETCHMODE_ASSOC);
			// 2009.07.24 add by sugi
			if(!isset($data)){
				return null;
			}
		}
		$data["img_src"] = $data["img_path"]."/".$data["img_fname"];
		// 2009.07.24 add by sugi --
		$data["gimg_src"] = $bpath . $pageu_code . '-'. $idx . '-' . date('YmdHis') . '_'.uniqid('b').'.' . array_pop(explode('.',$data["img_src"]));	// コピー先
		//--
		return $data;
	}

	/* 2009.07.31 yama */
	/*
	 *  img_code int 素材管理画像No
	 */
	function getImagePathFromCode($img_code) {
		if(!is_numeric($img_code)) {
			return null;
		}
		$data = null;
		$sql = 'select * from tbl_imgmngr where img_code = ? ';
		$result = $this->db->prepare($sql, array($img_code));
		if($result) {
			$data = $result->fetchRow(DB_FETCHMODE_ASSOC);
			if(!isset($data)){
				return null;
			}
		}
		return $data["img_path"]."/".$data["img_fname"];
	}

	/*
	 * 指定フォルダ内の画像取得処理
	 * $dir 指定フォルダ(BASE_PATH以下)
	 * $trash ゴミ箱の中を取得するか　2010.09.23 sugi
	 * $all 権限を無視して全て取得するか
	 * return array(画像リスト)
	 */
	function getSelectImages($dir=null, $trash=false, $all=false){
		$db_imagelist = null;
		$path = BASE_PATH.$dir;

		if(!is_dir($path)){
			return false;
		}

		//DBから選択されたフォルダの画像を一括取得
		$result = null;
		$values=array();
		$sql = 'select * from tbl_imgmngr WHERE 1=1';
		// 2009.08.04 mod by sugi -- 降順に修正
		//$order = ' order by img_code asc';
		$order = $this->get_order();
		//--

		/*
		if(!$all){
			$sql .=" AND (img_usr_code=? OR img_share=1)";
			$values[] = $_SESSION["usr_info"]["usr_code"];
		}
		*/
		if($dir != null) {
			$sql .= " AND img_path like ? ";
			$values[] = $dir;
			$result = $this->db->prepare($sql.$order, $values);
		} else {
			//2010.09.23 sugi
			if (!$trash) {
				$sql .= " AND img_path <> '". $this->trash_path . "' ";
			}
			$result = $this->db->prepare($sql.$order, $values);
		}
		$label_ar = $this->getLabelInfo(array(), $all);	// ラベル設定情報取得 2010.05.17 sugi

		$db_imagelist = null;
		$db_imagelist_all = null;
		$db_imgflist = null;
		if($result != null) {
			while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
        if(!is_dir(BASE_PATH.$row["img_path"]) || !$this->authFolderCheck(BASE_PATH.$row["img_path"], $all)){
        	continue;
				}
				if( is_file(BASE_PATH.$row["img_path"]."/".$row["img_fname"]) ) {
					$row["src"] = $row["img_path"]."/".$row["img_fname"];
					//$row["src"] = $row["img_path"]."/".$row["img_fname"] . '?' . date('YmdHis');
					$finfo = pathinfo(BASE_PATH.$row["img_path"]."/".$row["img_fname"]);
					$this->setFormerImage(BASE_PATH.$row["img_path"]."/".$row["img_fname"]);
					$row["fwidth"] = $this->getWidth();
					$row["fheight"] = $this->getHeight();
					$row["ftype"] = $finfo["extension"];

					//2010.09.28 sugi
					if ($this->rootpath == $row['img_path']) {
						$row["img_path_p"] = $this->rootpath;
						$row["img_path_d"] = "";
					}else{
						$img_path_ar = explode('/', $row['img_path']);
						$row["img_path_d"] = array_pop($img_path_ar);
						$row["img_path_p"] = implode('/', $img_path_ar);
					}

					if (isset($label_ar[$row["img_code"]])) {
						$row["labels"] = $label_ar[$row["img_code"]];
					}
          if($all){
						$db_imagelist[$row["img_code"]] = $row;

					//}else if($row["img_usr_code"] == $_SESSION["usr_info"]["usr_code"]){
          			} else if ($this->getAuthUserCode(BASE_PATH.$row['img_path']) == $_SESSION["usr_info"]["usr_code"]) {
						$db_imagelist[$row["img_code"]] = $row;
					}
					$db_imagelist_all[$row["img_code"]] = $row;
					$db_imgflist[] = $row["img_fname"];
				}
			}
		}

if (!empty($dir)) {	// 2010.09.23 sugi
		//サーバ上のファイル一覧を取得 2009.06.23
		//バージョンアップ時に更新するか、悩み中・・・・
		//データベースに入っていないファイルが見つかったら保存処理をかける
		if($handle = opendir($path)){
			while(false !== ($file = readdir($handle))){
				if(is_file($path."/".$file) && !preg_match("/^\..*/", $file)){//隠しファイル以外
					//DBに登録されているか調査
					if( !is_array($db_imagelist_all) || (is_array($db_imagelist_all) && !in_array($file, $db_imgflist)) ) {
						$save_record = array("img_path"=>$dir,
														"img_fname"=>$file,
														"img_name"=>$file
												);
						$img_code = $this->insert($save_record);
						if(is_numeric($img_code)) {
							$save_record["src"] = $dir."/".$file;
							//$save_record["src"] = $dir."/".$file . '?' . date('YmdHis');;
							$finfo = pathinfo(BASE_PATH.$dir."/".$file);
							$this->setFormerImage(BASE_PATH.$dir."/".$file);
							$save_record["fwidth"] = $this->getWidth();
							$save_record["fheight"] = $this->getHeight();
							$save_record["ftype"] = $finfo["extension"];

							//2010.09.28 sugi
							if ($this->rootpath == $save_record['img_path']) {
								$save_record["img_path_p"] = $this->rootpath;
								$save_record["img_path_d"] = "";
							}else{
								$img_path_ar = explode('/', $save_record['img_path']);
								$save_record["img_path_d"] = array_pop($img_path_ar);
								$save_record["img_path_p"] = implode('/', $img_path_ar);
							}

							$db_imagelist[$img_code] = $save_record;
						}
					}
				}
			}
		}
}
		return $db_imagelist;
	}

	/*
	 * 指定ラベルが設定されている画像取得処理
	 * $label_code ラベルコード
	 * return array(画像リスト)
	 */
	function getLabelImages($label_code=null, $all=false){
		$db_imagelist = null;

		if (!is_numeric($label_code)) {
			return false;
		}

		//DBから指定ラベルが設定されている画像を一括取得
		$result = null;
		$values=array();
		$sql = "select * from tbl_imgmngr
				inner join tbl_imgmngr_labellnk on (tbl_imgmngr.img_code = tbl_imgmngr_labellnk.img_code and tbl_imgmngr.img_path <> '". $this->trash_path . "')
				inner join tbl_label on tbl_imgmngr_labellnk.label_code = tbl_label.label_code WHERE 1=1";
		$order = $this->get_order();

		if(!$all){
			$sql .=" AND (img_usr_code=? OR img_share=1)";
			$values[] = $_SESSION["usr_info"]["usr_code"];
		}

		if($label_code != null) {
			$sql .= " AND tbl_label.label_code = ? ";
			$values[] = $label_code;
			$result = $this->db->prepare($sql.$order, $values);
		} else {
			$result = $this->db->prepare($sql.$order, $values);
		}

		$label_ar = $this->getLabelInfo(array(), $all);	// ラベル設定情報取得

		$db_imagelist = null;
		$db_imgflist = null;
		if($result != null) {
			while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
				if( is_file(BASE_PATH.$row["img_path"]."/".$row["img_fname"]) ) {
					$row["src"] = $row["img_path"]."/".$row["img_fname"];
					//$row["src"] = $row["img_path"]."/".$row["img_fname"] . '?' . date('YmdHis');
					$finfo = pathinfo(BASE_PATH.$row["img_path"]."/".$row["img_fname"]);
					$this->setFormerImage(BASE_PATH.$row["img_path"]."/".$row["img_fname"]);
					$row["fwidth"] = $this->getWidth();
					$row["fheight"] = $this->getHeight();
					$row["ftype"] = $finfo["extension"];

					//2010.09.28 sugi
					if ($this->rootpath == $row['img_path']) {
						$row["img_path_p"] = $this->rootpath;
						$row["img_path_d"] = "";
					}else{
						$img_path_ar = explode('/', $row['img_path']);
						$row["img_path_d"] = array_pop($img_path_ar);
						$row["img_path_p"] = implode('/', $img_path_ar);
					}

					if (isset($label_ar[$row["img_code"]])) {
						$row["labels"] = $label_ar[$row["img_code"]];
					}
					$db_imagelist[$row["img_code"]] = $row;
					$db_imgflist[] = $row["img_fname"];
				}
			}
		}
		return $db_imagelist;
	}


	/**
	 * 最後にアップロードされた素材リストを取得 2010.06.07 sugi
	 * @return array or null
	 */
	function getLastUpImages($all=false) {
		$db_imagelist = null;

		//DBから選択されたフォルダの画像を一括取得
		$result = null;
		$values=array();
		$sql = 'select max(img_up_number) as img_up_number from tbl_imgmngr ';
		//if(!$all){
			$sql .=" WHERE (img_usr_code=? OR img_share=1)";
			$values[] = $_SESSION["usr_info"]["usr_code"];
		//}
		$img_up_number = $this->db->db->getOne($sql, $values);
		if (!is_numeric($img_up_number)) {
			return null;
		}
		$sql = "select * from tbl_imgmngr where img_up_number = {$img_up_number} and img_path <> '{$this->trash_path}'" ;
		$order = $this->get_order();

		//if(!$all){
			$sql .=" and (img_usr_code=? OR img_share=1)";
		//}

		$result = $this->db->prepare($sql.$order, $values);

		$label_ar = $this->getLabelInfo();	// ラベル設定情報取得 2010.05.17 sugi

		$db_imagelist = null;
		$db_imgflist = null;
		if($result != null) {
			while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
				if(!is_dir(BASE_PATH.$row["img_path"]) || !$this->authFolderCheck(BASE_PATH.$row["img_path"], $all)){
					continue;
				}
				if( is_file(BASE_PATH.$row["img_path"]."/".$row["img_fname"]) ) {
					$row["src"] = $row["img_path"]."/".$row["img_fname"];
					//$row["src"] = $row["img_path"]."/".$row["img_fname"] . '?' . date('YmdHis');
					$finfo = pathinfo(BASE_PATH.$row["img_path"]."/".$row["img_fname"]);
					$this->setFormerImage(BASE_PATH.$row["img_path"]."/".$row["img_fname"]);
					$row["fwidth"] = $this->getWidth();
					$row["fheight"] = $this->getHeight();
					$row["ftype"] = $finfo["extension"];

					//2010.09.28 sugi
					if ($this->rootpath == $row['img_path']) {
						$row["img_path_p"] = $this->rootpath;
						$row["img_path_d"] = "";
					}else{
						$img_path_ar = explode('/', $row['img_path']);
						$row["img_path_d"] = array_pop($img_path_ar);
						$row["img_path_p"] = implode('/', $img_path_ar);
					}

					if (isset($label_ar[$row["img_code"]])) {
						$row["labels"] = $label_ar[$row["img_code"]];
					}
					$db_imagelist[$row["img_code"]] = $row;
					$db_imgflist[] = $row["img_fname"];
				}
			}
		}

		return $db_imagelist;
	}

  /**
	 * 最後にアップロードされた素材リストを取得 2010.06.07 sugi
	 * @return array or null
	 */
	function getShareImages($all=false) {
		$db_imagelist = null;

		$result = null;
		$values=array();
		$sql = 'select * from tbl_imgmngr WHERE img_share = 1 order by img_up_number desc, img_code desc';

		$result = $this->db->prepare($sql.$order, $values);
		$label_ar = $this->getLabelInfo();	// ラベル設定情報取得 2010.05.17 sugi

		$db_imagelist = null;
		$db_imgflist = null;
		if($result != null) {
			while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){

				if($row["img_share"]!=1 && (!is_dir(BASE_PATH.$row["img_path"]) || !$this->authFolderCheck(BASE_PATH.$row["img_path"], $all))){
					continue;
				}
//				if( is_file(BASE_PATH.$row["img_path"]."/".$row["img_fname"]) ) {
//ゴミ箱のぞく
				if( is_file(BASE_PATH.$row["img_path"]."/".$row["img_fname"]) && $row["img_path"] != "/global-data/trash") {
					$row["src"] = $row["img_path"]."/".$row["img_fname"];
					//$row["src"] = $row["img_path"]."/".$row["img_fname"] . '?' . date('YmdHis');
					$finfo = pathinfo(BASE_PATH.$row["img_path"]."/".$row["img_fname"]);
					$this->setFormerImage(BASE_PATH.$row["img_path"]."/".$row["img_fname"]);
					$row["fwidth"] = $this->getWidth();
					$row["fheight"] = $this->getHeight();
					$row["ftype"] = $finfo["extension"];

					//2010.09.28 sugi
					if ($this->rootpath == $row['img_path']) {
						$row["img_path_p"] = $this->rootpath;
						$row["img_path_d"] = "";
					}else{
						$img_path_ar = explode('/', $row['img_path']);
						$row["img_path_d"] = array_pop($img_path_ar);
						$row["img_path_p"] = implode('/', $img_path_ar);
					}

					if (isset($label_ar[$row["img_code"]])) {
						$row["labels"] = $label_ar[$row["img_code"]];
					}
					$db_imagelist[$row["img_code"]] = $row;
					$db_imgflist[] = $row["img_fname"];
				}
			}
		}

		return $db_imagelist;
	}

	function insert( $record, $trans=true )
	{
		if(!is_array($record)) {
			return false;
		}
		//作成日、更新日追加 2010.06.07 sugi
		$record['img_c_date'] = "now()";
		$record['img_u_date'] = "now()";

		if(!isset($record['img_usr_code']) || !is_numeric($record['img_usr_code'])){
			$record['img_usr_code'] = $_SESSION["usr_info"]["usr_code"];
		}

		if ($trans) $this->db->query('BEGIN');
		$record["img_code"] = $this->db->getKey("tbl_imgmngr_img_code");//登録ID
		if($this->db->insert("tbl_imgmngr",$record)) {
			if ($trans) $this->db->query('COMMIT');
			return $record["img_code"];
		}
		if ($trans) $this->db->query('ROLLBACK');
		return false;
	}

	// 2009.08.03 add by sugi
	function select($where = null){
		$sql = 'select * from tbl_imgmngr ';
		if($where !== null){
			$sql .= " where ". $where;
		}
		$result = $this->db->query($sql.$order);
		$rtn = null;
		if($result != null) {
			while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
				$rtn[] = $row;
			}
		}
		return $rtn;
	}
	//--
	// 2009.07.29 add by sugi
	function update( $record , $where, $trans=true){
		if(!is_array($record)) {
			return false;
		}

		//更新日追加 2010.06.07 sugi
		$record['img_u_date'] = "now()";

		if($trans) $this->db->query('BEGIN');
		if($this->db->update("tbl_imgmngr",$record, $where)) {
			if($trans) $this->db->query('COMMIT');
			return true;
		}
		if($trans) $this->db->query('ROLLBACK');
		return false;
	}
	//--

	function setFormerImage($image){
		//$this->former_image = $this->imagecreatefromext($image);
		//$this->former_width = imageSX($this->former_image);
		//$this->former_height= imageSY($this->former_image);
		list($this->former_width, $this->former_height, $type, $attr) = getimagesize($image);
		$this->setName($image);
	}

	function getWidth(){
		return $this->former_width;
	}

	function getHeight(){
		return $this->former_height;
	}

	function getSize(){
		return "width:".$this->former_width."px; height:".$this->former_height.";";
	}

	function getExt($filename){
		return $ext = array_pop(explode(".",$filename));
	}

	//保存ファイル名の取得
	function getSaveFileName($filename) {
		// 2009.08.05 mod by sugi--
		//return date(YmdHis).round(rand(0,50)).".".$this->getExt($filename);
		// １ミリ秒スリープ（PHP 5.0.0 より前のバージョンでは、以下の関数は Windows システム上では 動作しない）
		usleep(1000);
		// ミリ秒単位まで算出しファイル名を生成
		return date('YmdHis').round((float)microtime() * 1000).".".$this->getExt($filename);
		//--
	}

	function getDetail($code){
		if(!is_numeric($code)) {
			return null;
		}
		$sql = "SELECT * FROM tbl_imgmngr WHERE img_code = ? limit 1";
		$result = $this->db->prepare($sql,array($code));
		if($result){
			$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
			return $row;
		} else {
			return null;
		}
	}

	function authFolderCheck($path, $admin=false){
		$auth = true;
		if($admin) return $auth;
		 // 作成するファイル名の指定
		$file_name = $path."/.auth";

		if(file_exists($file_name)){
			// ファイルポインタを開く
			$fp = fopen( $file_name, 'r' );
			// データが無くなるまでファイルを１行ずつ読み込む
			while( $get_line = fgets( $fp, 256 ) ) {
				$code = $get_line;
			}
			fclose( $fp );
			$auth = intVal($_SESSION["usr_info"]["usr_code"]) === intVal($code);
		}else{
			$auth = false;
		}
		return $auth;
	}

	function authFileCheck($path){
		return true;
	}

	function getAuthUserCode($path, $user_root_check=true){

		if ($user_root_check && preg_match("/^".preg_quote(BASE_PATH.GDATA_UP_DIR, "/")."\/user(\d+)/", $path, $matches)) {
			$file_name = BASE_PATH.GDATA_UP_DIR."/user{$matches[1]}/.auth";
		} else {
			$file_name = $path."/.auth";
		}
		if (isset($this->_getAuthUserCode[$file_name])) {
			return $this->_getAuthUserCode[$file_name];
		}
		$this->_getAuthUserCode[$file_name] = false;
		if(file_exists($file_name)){
			// ファイルポインタを開く
			$fp = fopen( $file_name, 'r' );
			// データが無くなるまでファイルを１行ずつ読み込む
			while( $get_line = fgets( $fp, 256 ) ) {
				$code = $get_line;
			}
			fclose( $fp );
			$this->_getAuthUserCode[$file_name] = $code;
		}
		return $this->_getAuthUserCode[$file_name];
	}

	function uniqueCheck($img_code=null, $img_name){
		$sql = "select count(img_name) as cnt from tbl_imgmngr where img_name = ? ";
		if($img_code!=null) {
			$sql .= " and img_code <> ?";
			$result = $this->db->prepare($sql,array($img_name, $img_code));
		} else {
			$result = $this->db->prepare($sql,array($img_name));
		}

		if(!empty($result)){
			$row = $result -> fetchRow(DB_FETCHMODE_ASSOC);
			if($row["cnt"] > 0){
				return false;
			}
		}
		return true;
	}

	/**
	 * ラベル毎の件数取得
	 * @access public
	 * @param $label_code
	 * @return null or array
	 */
	function getCountList($label_code = null, $all=false) {
		$sql = "select label_code, count(*) as cnt from tbl_imgmngr_labellnk
				inner join tbl_imgmngr on tbl_imgmngr_labellnk.img_code = tbl_imgmngr.img_code
				where 1=1 ";
		if (is_numeric($label_code)) {
			$sql .= " and label_code = {$label_code} ";
		}

		if(!$all){
			$sql .= " and (img_usr_code = ".$_SESSION["usr_info"]["usr_code"]." OR img_share=1)";
		}

		$sql .= " and tbl_imgmngr.img_path <> '". $this->rootpath . "/". $this->trash_en . "' ";
		$sql .= " group by label_code";
		if (!($result = $this->db->query($sql))) {
			return null;
		}
		$rtn = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
			$rtn[$row['label_code']] = $row['cnt'];
		}
		return $rtn;
	}

	/**
	 * ラベル設定されているデータ一覧取得
	 * @access public
	 * @param $label_code
	 * @return array
	 */
	function getLabelImgList($label_code = null) {
		$rtn = array();
		if (!is_numeric($label_code)) {
			return $rtn;
		}
		$sql = "select * from tbl_imgmngr_labellnk where label_code = {$label_code}";
		if (!($result = $this->db->query($sql))) {
			return $rtn;
		}
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
			$rtn[$row['img_code']] = $row;
		}
		return $rtn;
	}
	/**
	 * ラベル設定
	 * @access public
	 * @param $label_code
	 * @param $img_codes
	 * @return false or true
	 */
	function setLabel($label_code = null, $img_codes = array()) {
		if (!is_numeric($label_code)) {
			return false;
		}
		if (!is_array($img_codes) || count($img_codes) === 0) {
			return false;
		}
		// 対象ラベルの素材一覧を取得
		$list = $this->getLabelImgList($label_code);
		$this->db->query('BEGIN');
		foreach ($img_codes as $img_code) {
			if (isset($list[$img_code])) {
				continue;	// 既に登録されている場合は無視
			}
			$record = array();
			$record['img_code'] = $img_code;
			$record['label_code'] = $label_code;
			if(!$this->db->insert("tbl_imgmngr_labellnk",$record)) {
				$this->db->query('ROLLBACK');
				return false;
			}
		}
		$this->db->query('COMMIT');
		return true;
	}
	/**
	 * ラベルを剥がす
	 * @access public
	 * @param $label_code
	 * @param $img_codes	設定されていない場合は、対象ラベルのリンクを全て解除
	 * @return false or true
	 */
	function peelLabel($label_code = null, $img_codes = array()) {
		if (!is_numeric($label_code)) {
			return false;
		}

		$this->db->query('BEGIN');
		if ($img_codes == null || !is_array($img_codes) || count($img_codes) === 0) {
			if(!$this->db->delete("tbl_imgmngr_labellnk",$where = " label_code = {$label_code}")) {
				$this->db->query('ROLLBACK');
				return false;
			}
		} else {
			// 対象ラベルの素材一覧を取得
			$list = $this->getLabelImgList($label_code);
			foreach ($img_codes as $img_code) {
				if (!isset($list[$img_code])) {
					continue;	// 登録されていない場合は無視
				}
				$record = array();
				$record['img_code'] = $img_code;
				$record['label_code'] = $label_code;
				if(!$this->db->delete("tbl_imgmngr_labellnk",$where = " img_code = {$img_code} and label_code = {$label_code}")) {
					$this->db->query('ROLLBACK');
					return false;
				}
			}
		}
		$this->db->query('COMMIT');
		return true;
	}

	/**
	 * ラベル情報取得
	 * @access public
	 * @param $img_codes	素材を絞る
	 * @return false or true
	 */
	function getLabelInfo($img_codes = array(), $all=false) {

		$sql = "select img_code, tbl_label.label_code, label_name, label_color from tbl_imgmngr_labellnk
		inner join tbl_label on tbl_imgmngr_labellnk.label_code = tbl_label.label_code
		where 1=1 ";
		if (is_array($img_codes) && count($img_codes) > 0) {
			$sql .= " and tbl_imgmngr_labellnk.img_code in (".implode(',', $img_codes).") ";
		}

		if(!$all){
			$sql .=" and label_usr_code = ?";
			$values[] = $_SESSION["usr_info"]["usr_code"];
		}

		$sql .= " order by tbl_label.label_order, tbl_label.label_code";	// ソート順 2010.07.09 sugi
		if (!$result = $this->db->prepare($sql, $values)) {
			return array();
		}
		$rtn = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
			$rtn[$row['img_code']][] = $row;
		}
		return $rtn;
	}

	/**
	 * 次回アップロードまで保持するテーブルに登録
	 * @access public
	 * @param $img_code
	 */
	function tmpInsert($img_code) {
		if (!is_numeric($img_code)) {
			return false;
		}
		$this->db->query('BEGIN');
		$record = array();
		$record['img_code'] = $img_code;
		if(!$this->db->insert("tbl_imgmngr_tmp", $record)) {
			$this->db->query('ROLLBACK');
			return false;
		}
		$this->db->query('COMMIT');
		return true;
	}
	/**
	 * 次回アップロードまで保持するテーブルをクリア
	 * @access public
	 * @param $img_code
	 */
	function tmpClear() {
		$this->db->query('BEGIN');
		$sql = "delete from tbl_imgmngr_tmp";
		if(($result = $this->db->query($sql)) == null) {
			$this->db->query('ROLLBACK');
			return false;
		}
		$this->db->query('COMMIT');
		return true;
	}

	/**
	 * アップロードファイルのアップロード番号を素材管理に登録
	 * @access public
	 * @param $img_code
	 */
	function tmpToImg() {
		$sql = "select max(img_up_number) as img_up_number from tbl_imgmngr";
		$img_up_number = $this->db->getOne($sql);
		if (is_numeric($img_up_number)) {
			$img_up_number++;
		} else {
			$img_up_number = 1;
		}
		$sql = "select img_code from tbl_imgmngr_tmp";
		if(($result = $this->db->query($sql)) == null) {
			return false;
		}
		$img_codes = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
			$img_codes[] = $row['img_code'];
		}

		if (count($img_codes) > 0) {
			$this->db->query('BEGIN');
			$sql = "update tbl_imgmngr set img_up_number = {$img_up_number} where img_code in (" . implode(',', $img_codes) . ")";
			if(($result = $this->db->query($sql)) == null) {
				$this->db->query('ROLLBACK');
				return false;
			}
			$this->db->query('COMMIT');
		}
		return true;
	}

	/**
	 * ソート条件文取得
	 * @access public
	 * @return ソート条件文字列
	 */
	function get_order() {
		if ($this->name_sort) {
			return ' order by tbl_imgmngr.img_name';
		} else
		return ' order by tbl_imgmngr.img_code desc';
	}

	/**
	*   [getter]編集画面の画像サイズ
	*   @version 1.5.0
	*   @param integer  $rat_code
	*   @param integer  $usr_code
	*   @param boolean $select_code
	*   @return array
	*/
	function getRatio($rat_code=null, $usr_code=null, $select=FALSE){
		$data = array();
		$sql = "SELECT * FROM tbl_imgmngr_ratio WHERE rat_active=1";
		$value=array();
		if(is_numeric($rat_code)){
			$sql =" AND rat_code=?";
			$value[] = $rat_code;
		}
		if(is_numeric($usr_code)){
			$sql =" AND rat_usr_code=?";
			$value[] = $usr_code;
		}
		$ret = $this->db->prepare($sql, $value);
		if($ret){
			while($row = $ret->fetchRow(DB_FETCHMODE_ASSOC)){
				if($select===FALSE){
					$data[] = $row;
				}else{
					$data[$row["rat_size"]] = $row["rat_name"];
				}
			}
		}
		return $data;
	}

	/**
	*   [setter]編集画面の画像サイズ。トランザクションは呼び出し側で行ってください。
	*   @param integer $rat_code
	*   @data array $data
	*   @return boolean
	*/
	function setRatio($rat_code=null, $data){
		if(is_numeric($rat_code)){
		//更新
			if(!$this->db->update("tbl_imgmngr_ratio", $data, "rat_code=".$rat_code)){
				return false;
			}
		}else{
		//新規
			if(!$this->db->insert("tbl_imgmngr_ratio", $data)){
				return false;
			}
		}
		return true;
	}

	/**
	*   [setter]編集画面の画像サイズ。トランザクションは呼び出し側で行ってください。
	*   @param integer $rat_code
	*   @data array $data
	*   @return boolean
	*/
	function addRatio($ratio){
		$count = $this->db->getOne("SELECT count(rat_code) FROM tbl_imgmngr_ratio WHERE rat_active = 1 AND rat_size = ?", $ratio);
		if($count > 0){
			return "既に登録されています";
		}
		if(!preg_match("/^[\d]+:[\d]+$/", $ratio)){
			return "サイズが不正です";
		}

		$data = array(
			"rat_name" => $ratio
			,"rat_usr_code" => $_SESSION["usr_info"]["usr_code"]
			,"rat_size" => $ratio
			,"rat_c_date" => date('Y-m-d H:i:s')
			,"rat_u_date" => date('Y-m-d H:i:s')
			,"rat_active" => '1'
		);
		return $this->setRatio(null, $data);
	}

	function delRatio($ratio){
		$ret = $this->db->prepare("SELECT rat_code FROM tbl_imgmngr_ratio WHERE rat_size = ?", $ratio);
		if(PEAR::isError($ret)){
			return "削除に失敗しました";
		}
		$rat = $ret->fetchRow(DB_FETCHMODE_ASSOC);
		if(!$ret){
			return true;
		}
		$data = array(
			"rat_u_date" => date('Y-m-d H:i:s')
			,"rat_active" => '0'
		);
		return $this->setRatio($rat["rat_code"], $data);
	}



	function getVideo($u, $option=null){
		$k = "youtube";
		if(preg_match("/https?:\/\/vimeo.com\/.*/", $u)){
			$k = "vimeo";
		}

		if($k == "youtube"){
			return $this->getYoutube($u,$option);
		}

		if($k == "vimeo"){
			return $this->getVimeo($u,$option);
		}
		return array("ERROR"=>"動画が見つかりませんでした。");
	}

	function getYoutube($u,$option){
		$videoId = array_pop(explode("/", $u));
    if(defined("GOOGLE_API_KEY") && GOOGLE_API_KEY!="" && function_exists('json_decode')){
      $api_url=$this->media_service_api["youtube"]."?part=snippet,contentDetails,player&key=".GOOGLE_API_KEY."&id=".$videoId;
      if(function_exists('curl_init') && function_exists('json_decode')){
        $ch = curl_init($api_url);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
        $response = curl_exec($ch);
        curl_close($ch);
      }else{
        if(ini_get("allow_url_fopen")){
          $response = file_get_contents($api_url);
        }
      }
      $result = json_decode($response);

      if($result==NULL || $result->error){
        return array("ERROR"=>"動画の取得に失敗しました。");
      }
    }

    $item = $result->items[0];
		$data = array();

		$data["type"] = "youtube";
		//$data["category"] = $result["media:group"]["media:category"];
		$data["title"] = $item->snippet->title;
		//$data["content"] = $result["media:group"]["media:content"];
		$data["description"] = $item->snippet->description;
		//$data["author"] = $result["author"];
    /*
		$data["player"] = $result["media:group"]["media:player"]["url"];
    */
    $data["player"] = $item->player->embedHtml;
    $data["url"] = "//www.youtube.com/embed/".$videoId."?wmode=transparent";
    if($option["autoplay"]){
			$data["url"] .="&amp;autoplay=1";
		}
		if($option["loop"]){
			$data["url"] .="&amp;loop=1&amp;playlist={$videoId}";
		}
    $thumbnail = (array)$item->snippet->thumbnails;
    $thumbnail = array_pop($thumbnail);
    if($thumbnail){
      $data["thumbnail"][0]["url"] = $thumbnail->url;
      $data["thumbnail"][0]["width"] = $thumbnail->width;
      $data["thumbnail"][0]["height"] = $thumbnail->height;
    }
		$data["videoId"] = $videoId;

    /*
		$duration = $result["media:group"]["yt:duration"]["seconds"];
		$min = floor($duration/60);
		$sec = $duration - $min*60;
		$data["duration"] = array(
			"minute" => $min."分".$sec."秒"
			,"seconds" => $duration
		);
    */
		return $data;
	}

	function getVimeo($u, $option){
		if(function_exists('curl_init')){
			$ch = curl_init($this->media_service_api["vimeo"]."?url=".$u);
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 10);
			curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
			$xml = curl_exec($ch);
			curl_close($ch);
		}else{
			$xml = file_get_contents($this->media_service_api["vimeo"]."?url=".$u);
		}

		if($xml===false){
			return array("ERROR"=>"vimeoへの接続に失敗しました。");
		}

		include_once("XML/Unserializer.php");
		$options = array(
		  XML_UNSERIALIZER_OPTION_ATTRIBUTES_PARSE => 'parseAttributes'
		);
		$unserializer = new XML_Unserializer($options);
		$unserializer->unserialize($xml);
		$result = $unserializer->getUnserializedData();

		if(PEAR::isError($result)){
			return array("ERROR"=>"動画の取得に失敗しました。");
		}
    $class=isset($option["class"]) ? $option["class"]: "bg-media-video";
		$data = array();
		$data["type"] = "vimeo";
		$data["title"] = $result["title"];
		$data["description"] = $result["description"];
		$data["author_name"] = $result["author_name"];
		$data["author_url"] = $result["author_url"];
		$data["player"] = str_replace("<iframe ", "<iframe class=\"".$class."\" id=\"madia-video{$option["key"]}\" ", $result["html"]);
		preg_match('/src="([\S\s]*?)"/',$data["player"], $match);
		$src = $match[1]."?wmode=transparent";
		if($option["autoplay"]){
			$src.="&amp;autoplay=true";
		}
		if($option["loop"]){
			$src.="&amp;loop=1";
		}

		$src.="&amp;api=1&amp;player_id=madia-video{$option["key"]}";
		$data["player"] = str_replace($match[1], $src, $data["player"]);
    $data["url"] = $src;
    $data["videoId"] = $result["video_id"];
		$data["width"] = $result["width"];
		$data["height"] = $result["height"];
		$data["thumbnail"] = array(
			array(
				"url"=>$result["thumbnail_url"]
				,"width"=>$result["thumbnail_width"]
				,"height"=>$result["thumbnail_height"]
			)
		);
		$data["videoId"] = $result["video_id"];
		$duration = $result["duration"];
		$min = floor($duration/60);
		$sec = $duration - $min*60;
		$data["duration"] = array(
			"minute" => $min."分".$sec."秒"
			,"seconds" => $duration
		);
		return $data;
	}
	/**
     * getimagesize のSVG対応用のラッパー
     *
     * @param [type] $path [description]
     *
     * @return [type] [description]
     */
    public function getimagesizeall($path)
    {
        $ext = strtolower($this->getExt($path));
        if (preg_match("/jpe?g|gif|png|svg/", $ext)) {
            $info = getimagesize($path);
            if ($info !== false) {
                return $info;
            }
            //falseの時はSVGと仮定
            $xml = @simplexml_load_file($path);
            if ($xml === false) {
                //SVGでもない時はnull
                return;
            }

            if (isset($xml['width']) && isset($xml['height'])) {
                $w = $xml["width"];
                $h = $xml["height"];
                $w = strtr($w, array('%'=>'','px'=>''));
                $h = strtr($h, array('%'=>'','px'=>''));
                $xml["viewBox"] = "0 0 {$w} {$h}";

                $info=array(
                    (string) $w,
                    (string) $h,
                    0,
                    'width="'.(string) $w.'" height="'.(string) $h.'"',
                    'mime' => 'image/svg+xml',
                );

                unset($xml["width"]);
                unset($xml["height"]);

                file_put_contents($path, $xml->asXML());

                return $info;
            } elseif (isset($xml['viewBox'])) {
                if (preg_match("/\d+ \d+ (\d+) (\d+)/", $xml['viewBox'], $m)) {
                    $info=array(
                        (string) $m[1],
                        (string) $m[2],
                        0,
                        'width="'.(string) $m[1].'" height="'.(string) $m[2].'"',
                        'mime' => 'image/svg+xml',
                    );

                    return $info;
                }
            }
        } else {
            //画像ファイル以外
            return array(
                null,
                null,
                0,
                '',
                'mime' => null,
            );
        }


        // $info = getimagesize($path);
        // if ($info !== false) {
        //     return $info;
        // }



        return;
    }

	/**
     * 画像メタ情報を取得
     *
     * @param string $file 画像パス
     * @return [type] [description]
     */
    public function getMeta($file)
    {
        $exif = null;
        if (is_file($file)) {
            $finfo = $this->getimagesizeall($file);
            if ($finfo[2] == IMAGETYPE_JPEG && function_exists('exif_read_data')) {
                try {
                    $exif = @exif_read_data($file);
                } catch (Exeption $e) {
                    $exif = null;
                }
                if ($exif) {
                    if (isset($exif['GPSLatitudeRef']) && $exif['GPSLatitudeRef'] != '') {
                        $gpsConver = $this->convertGPS($exif['GPSLatitudeRef'], $exif['GPSLatitude'], $exif['GPSLongitudeRef'], $exif['GPSLongitude'], 10);
                        $exif['GPSLatitudeConvert'] = $gpsConver['Latitude'];
                        $exif['GPSLongitudeConvert'] = $gpsConver['Longitude'];
                    }
                    foreach ($exif as $k=>$v) {
                        if (strpos(strtolower($k), "undefined")===0) {
                            $exif[$k] = base64_encode($v);
                        }
                    }
                }
            }
        }

        return $exif;
    }

		/**
     * 位置情報を保存用に変換.
     *
     * @param string $latRef 縦軸の方角 N(北) or S(南)
     * @param array  $lat    緯度  [度,分,秒]
     * @param string $lngRef 縦軸の方角 E(東) or W(西)
     * @param array  $lng    経度  [度,分,秒]
     * @param int    $number 60 or 10 　変換する進数
     *
     * @return array
     */
    public function convertGPS($latRef, $lat, $lngRef, $lng, $number = 60)
    {
        $latlng = array(
            'Latitude' => '',
            'Longitude' => '',
        );
        $latlngConvert = function ($n) {
            $a = explode('/', $n);
            if ($num == 60) {
                return intval($a[0]) / intval($a[1]);
            } else {
                return intval($a[0]) / intval($a[1]);
            }
        };
        if ($number == 60) {
            $latlng['Latitude'] = $latlngConvert($lat[0]).'° '.$latlngConvert($lat[1]).'’ '.$latlngConvert($lat[2]).'” '.$latRef;
            $latlng['Longitude'] = $latlngConvert($lng[0]).'° '.$latlngConvert($lng[1]).'’ '.$latlngConvert($lng[2]).'” '.$lngRef;
        } elseif ($number == 10) {
            $latlng['Latitude'] = floatval($latlngConvert($lat[0])) + floatval($latlngConvert($lat[1]) / 60) + floatval($latlngConvert($lat[2]) / 3600);
            $latlng['Longitude'] = floatval($latlngConvert($lng[0])) + floatval($latlngConvert($lng[1]) / 60) + floatval($latlngConvert($lng[2]) / 3600);
        }

        return $latlng;
    }

}
?>
